using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_ControlGastos._0_Modelos;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Exferia_ControlGastos._1_Datos
{
    public class CTG_OrdenComisionServiciosCabecera_Datos : ABS_Datos
    {
        #region Listados
        private List<INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo> g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_CTG = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTG_OrdenComisionServiciosCabecera).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo != null) && (g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Count() > 0))
                {
                    lst_CTG = g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_CTG;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTG = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTG_OrdenComisionServiciosCabecera).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo != null) && (g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Count() > 0))
                {
                    dnm_CTG = g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTG;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {

                bool bol_FiltrarEjercicio = false;
                DateTime? dtt_TemporadaInicio = null;
                DateTime? dtt_TemporadaFin = null;

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Ejercicio
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEjercicio)))
                        {
                            //Buscar el Modelo de Ejercicio
                            GEN_EjerciciosActivos_Empresa mdl_GEN_EjerciciosActivos_Empresa = Datos_Generales.GEN_EjerciciosActivos_Empresa_Obtener_Por_Id(mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR);

                            if (mdl_GEN_EjerciciosActivos_Empresa != null)
                            {
                                bol_FiltrarEjercicio = true;
                                dtt_TemporadaInicio = mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaInicio;
                                dtt_TemporadaFin = mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaFin;
                            }
                        }
                    }
                }

                string str_SQL =
                 " SELECT " +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.id) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.referencia) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.descripcion) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.estado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.estado) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.autorizado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.observaciones) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionColectiva) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionIndividual) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionOtros) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.documentacionAdicional) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.anticipo) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.equiposInformaticos) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.fecha) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fecha) + "," +
                     //ids
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idExpediente) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEmpleado_Propuesto) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "," +
                     nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEmpleado_Autorizado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + "," +
                      //Expediente
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente)))
                               ?
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Numero) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.numero) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Descripcion) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.descripcion) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_FechaBorrado) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.fechaBorrado) + ","
                                   )
                               :
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Numero) + " = convert(bigint,-1)," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Descripcion) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_FechaBorrado) + " = NULL ,"
                                   )
                      ) +
                      //Empleado
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado)))
                               ?
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Codigo) + " = AUX_1." + nameof(MAE_Empleados.codigo) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Nombre) + " = AUX_1." + nameof(MAE_Empleados.nombre) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_FechaBorrado) + " = AUX_1." + nameof(MAE_Empleados.fechaBorrado) + ","
                                   )
                               :
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Codigo) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Nombre) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_FechaBorrado) + " = NULL ,"
                                   )
                      ) +
                      //Empleado_Propuesto
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto)))
                               ?
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Codigo) + " = AUX_2." + nameof(MAE_Empleados.codigo) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Nombre) + " = AUX_2." + nameof(MAE_Empleados.nombre) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_FechaBorrado) + " = AUX_2." + nameof(MAE_Empleados.fechaBorrado) + ","
                                   )
                               :
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Codigo) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Nombre) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_FechaBorrado) + " = NULL ,"
                                   )
                      ) +
                      //Empleado_Autorizado
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado)))
                               ?
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Codigo) + " = AUX_3." + nameof(MAE_Empleados.codigo) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Nombre) + " = AUX_3." + nameof(MAE_Empleados.nombre) + "," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_FechaBorrado) + " = AUX_3." + nameof(MAE_Empleados.fechaBorrado)
                                   )
                               :
                                   (
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Codigo) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Nombre) + " = ''," +
                                       nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_FechaBorrado) + " = NULL"
                                   )
                      ) +
                 " FROM " + nameof(CTG_OrdenComisionServiciosCabecera) +
                 //Expediente
                 (
                     (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente)))
                     ?
                         (
                                 " LEFT JOIN " + nameof(CTG_Expedientes) + " ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.id)
                         )
                     : ("")
                 ) +
                 //Empleado
                 (
                     (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado)))
                     ?
                         (
                                 " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_1 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) + " = AUX_1." + nameof(MAE_Empleados.id)
                         )
                     : ("")
                 ) +
                 //Empleado_Propuesto
                 (
                     (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto)))
                     ?
                         (
                                 " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_2 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + " = AUX_2." + nameof(MAE_Empleados.id)
                         )
                     : ("")
                 ) +
                 //Empleado_Autorizado
                 (
                     (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado)))
                     ?
                         (
                                 " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_3 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + " = AUX_3." + nameof(MAE_Empleados.id)
                         )
                     : ("")
                 ) +
                 " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + " IS null AND " +
                             (_lng_id > -1 ? nameof(CTG_OrdenComisionServiciosCabecera) + "." + (nameof(CTG_OrdenComisionServiciosCabecera.id) + "=@id") : "1 = 1") + " AND " +
                             //Ejercicio
                             " ( " +
                                 (
                                     bol_FiltrarEjercicio == true
                                         ? (nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fecha) + " <=@TemporadaFin AND " +
                                              nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fecha) + " >=@TemporadaInicio ")
                                         : " 1 = 1 "
                                 ) +
                             " ) ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@id", _lng_id),
                    new SqlParameter("@TemporadaFin", dtt_TemporadaFin),
                    new SqlParameter("@TemporadaInicio", dtt_TemporadaInicio)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

                //Añadir los Ejercicios
                if (g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo != null && g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Count > 0)
                {
                    Agregar_Ejercicios(_lng_idEmpresaSeleccionada);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        private void Agregar_Ejercicios(long _lng_idEmpresaSeleccionada)
        {
            try
            {
                List<GEN_EjerciciosActivos_Empresa> lst_GEN_EjerciciosActivos_Empresa = Datos_Generales.GEN_EjerciciosActivos_Empresa_Obtener_Listado_Por_Empresa(_lng_idEmpresaSeleccionada);

                if (lst_GEN_EjerciciosActivos_Empresa != null)
                {
                    //Rellenar el Listado
                    foreach (INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo in g_lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo)
                    {
                        mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Ejercicios_Empresa = lst_GEN_EjerciciosActivos_Empresa.Where(m => m.temporadaFechaFin >= mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.fecha &&
                                                                                                                                            m.temporadaFechaInicio <= mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.fecha)
                                                                                                                              .FirstOrDefault();
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Agregar_Ejercicios), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 7;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.id) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.referencia) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.descripcion) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.fecha) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fecha) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.estado) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.estado) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.autorizado) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.observaciones) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.accionColectiva) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.accionIndividual) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.accionOtros) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.documentacionAdicional) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.anticipo) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.equiposInformaticos) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "," +
                              //ids
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.idExpediente) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.idEmpleado_Propuesto) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.idEmpleado_Autorizado) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + "," +
                              nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo.idEmpleado) + "=" + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) +
                        " FROM " + nameof(CTG_OrdenComisionServiciosCabecera) +
                        " WHERE  " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + " IS null AND " +
                                     nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosCabecera_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //CTG_Expedientes ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idExpediente != null)
                    {
                        ThreadStart obj_ThreadStart_EXPEDIENTE = new ThreadStart(Obtener_Expediente_Modelo_Obtener);
                        Thread obj_Thread_EXPEDIENTE = new Thread(obj_ThreadStart_EXPEDIENTE);
                        obj_Thread_EXPEDIENTE.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_Empleados (Propuesto) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado_Propuesto != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADOPROPUESTO = new ThreadStart(Obtener_EmpleadoPropuesto_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADOPROPUESTO = new Thread(obj_ThreadStart_EMPLEADOPROPUESTO);
                        obj_Thread_EMPLEADOPROPUESTO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //MAE_Empleados (Autorizado) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado_Autorizado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADOAUTORIZADO = new ThreadStart(Obtener_EmpleadoAutorizado_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADOAUTORIZADO = new Thread(obj_ThreadStart_EMPLEADOAUTORIZADO);
                        obj_Thread_EMPLEADOAUTORIZADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[2] = true;
                    }

                    //MAE_Empleados ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADO = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADO = new Thread(obj_ThreadStart_EMPLEADO);
                        obj_Thread_EMPLEADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[3] = true;
                    }

                    //CTG_OrdenComisonServicioItinerario ##########################################################################################
                    ThreadStart obj_ThreadStart_ITINERARIO = new ThreadStart(Obtener_Itinerario_Modelo_Obtener);
                    Thread obj_Thread_ITINERARIO = new Thread(obj_ThreadStart_ITINERARIO);
                    obj_Thread_ITINERARIO.Start();

                    //CTG_OrdenComisonServicioHospedaje ##########################################################################################
                    ThreadStart obj_ThreadStart_HOSPEDAJE = new ThreadStart(Obtener_Hospedaje_Modelo_Obtener);
                    Thread obj_Thread_HOSPEDAJE = new Thread(obj_ThreadStart_HOSPEDAJE);
                    obj_Thread_HOSPEDAJE.Start();

                    //CTG_OrdenComisonServicioItinerario ##########################################################################################
                    ThreadStart obj_ThreadStart_GASTOS = new ThreadStart(Obtener_Gastos_Modelo_Obtener);
                    Thread obj_Thread_GASTOS = new Thread(obj_ThreadStart_GASTOS);
                    obj_Thread_GASTOS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Expediente_Modelo_Obtener()
        {
            try
            {
                CTG_Expedientes_Datos obj_CTG_Expedientes_Datos = new CTG_Expedientes_Datos();
                g_dnm_Modelo_Obtener.CTG_Expedientes = obj_CTG_Expedientes_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idExpediente);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_EmpleadoPropuesto_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado_Propuesto };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_EmpleadoAutorizado_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado_Autorizado };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados1 = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados2 = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[3] = true;
            }
        }
        private void Obtener_Itinerario_Modelo_Obtener()
        {
            try
            {
                CTG_OrdenComisionServiciosItinerarios_Datos obj_CTG_OrdenComisionServiciosItinerarios_Datos = new CTG_OrdenComisionServiciosItinerarios_Datos();
                g_dnm_Modelo_Obtener.Itinerario = obj_CTG_OrdenComisionServiciosItinerarios_Datos.Obtener_PorCabecera(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[4] = true;
            }
        }
        private void Obtener_Hospedaje_Modelo_Obtener()
        {
            try
            {
                CTG_OrdenComisionServiciosHospedaje_Datos obj_CTG_OrdenComisionServiciosHospedaje_Datos = new CTG_OrdenComisionServiciosHospedaje_Datos();
                g_dnm_Modelo_Obtener.Hospedaje = obj_CTG_OrdenComisionServiciosHospedaje_Datos.Obtener_PorCabecera(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[5] = true;
            }
        }
        private void Obtener_Gastos_Modelo_Obtener()
        {
            try
            {
                CTG_OrdenComisionServiciosGastos_Datos obj_CTG_OrdenComisionServiciosGastos_Datos = new CTG_OrdenComisionServiciosGastos_Datos();
                g_dnm_Modelo_Obtener.Gastos = obj_CTG_OrdenComisionServiciosGastos_Datos.Obtener_PorCabecera(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[6] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo> Obtener_PorExpediente(long _lng_idExpediente)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo> lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
               " SELECT " +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.id) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.referencia) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.descripcion) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.estado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.estado) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.autorizado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.observaciones) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionColectiva) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionIndividual) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionOtros) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.documentacionAdicional) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.anticipo) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.equiposInformaticos) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "," +
                   //ids
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idExpediente) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEmpleado_Propuesto) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "," +
                   nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEmpleado_Autorizado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + "," +
                  //Expediente
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Numero) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.numero) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Descripcion) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.descripcion) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_FechaBorrado) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.fechaBorrado) + "," +
                  //Empleado
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Codigo) + " = AUX_1." + nameof(MAE_Empleados.codigo) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Nombre) + " = AUX_1." + nameof(MAE_Empleados.nombre) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_FechaBorrado) + " = AUX_1." + nameof(MAE_Empleados.fechaBorrado) + "," +
                  //Empleado_Propuesto
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Codigo) + " = AUX_2." + nameof(MAE_Empleados.codigo) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Nombre) + " = AUX_2." + nameof(MAE_Empleados.nombre) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_FechaBorrado) + " = AUX_2." + nameof(MAE_Empleados.fechaBorrado) + "," +
                  //Empleado_Autorizado
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Codigo) + " = AUX_3." + nameof(MAE_Empleados.codigo) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Nombre) + " = AUX_3." + nameof(MAE_Empleados.nombre) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_FechaBorrado) + " = AUX_3." + nameof(MAE_Empleados.fechaBorrado) +
               " FROM " + nameof(CTG_OrdenComisionServiciosCabecera) +
               //Expediente
               " LEFT JOIN " + nameof(CTG_Expedientes) + " ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.id) +
               //Empleado
               " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_1 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) + " = AUX_1." + nameof(MAE_Empleados.id) +
               //Empleado_Propuesto
               " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_2 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + " = AUX_2." + nameof(MAE_Empleados.id) +
               //Empleado_Autorizado
               " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_3 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + " = AUX_3." + nameof(MAE_Empleados.id) +
               " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + " IS null AND " +
                           " ( NOT " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + " IS NULL ) AND " +
                           nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "=@idExpediente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@idExpediente", _lng_idExpediente),
                };

                //Rellenar el Modelo
                lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Obtener_PorExpediente), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo;
        }

        public INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo Obtener_ParaListado(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo = null;


            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
              " SELECT " +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.id) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.referencia) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.descripcion) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.estado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.estado) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.autorizado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.observaciones) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionColectiva) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionIndividual) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.accionOtros) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.documentacionAdicional) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.anticipo) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.equiposInformaticos) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "," +
                  //ids
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idExpediente) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEmpleado_Propuesto) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "," +
                  nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.idEmpleado_Autorizado) + " = " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) +
                 //Expediente
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Numero) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.numero) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_Descripcion) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.descripcion) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Expediente_FechaBorrado) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.fechaBorrado) + "," +
                 //Empleado
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Codigo) + " = AUX_1." + nameof(MAE_Empleados.codigo) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Nombre) + " = AUX_1." + nameof(MAE_Empleados.nombre) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_FechaBorrado) + " = AUX_1." + nameof(MAE_Empleados.fechaBorrado) + "," +
                 //Empleado_Propuesto
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Codigo) + " = AUX_2." + nameof(MAE_Empleados.codigo) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_Nombre) + " = AUX_2." + nameof(MAE_Empleados.nombre) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Propuesto_FechaBorrado) + " = AUX_2." + nameof(MAE_Empleados.fechaBorrado) + "," +
                 //Empleado_Autorizado
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Codigo) + " = AUX_3." + nameof(MAE_Empleados.codigo) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_Nombre) + " = AUX_3." + nameof(MAE_Empleados.nombre) + "," +
                 nameof(INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo.Empleado_Autorizado_FechaBorrado) + " = AUX_3." + nameof(MAE_Empleados.fechaBorrado) +
              " FROM " + nameof(CTG_OrdenComisionServiciosCabecera) +
              //Expediente
              " LEFT JOIN " + nameof(CTG_Expedientes) + " ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + " = " + nameof(CTG_Expedientes) + "." + nameof(CTG_Expedientes.id) +
              //Empleado
              " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_1 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) + " = AUX_1." + nameof(MAE_Empleados.id) +
              //Empleado_Propuesto
              " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_2 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + " = AUX_2." + nameof(MAE_Empleados.id) +
              //Empleado_Autorizado
              " LEFT JOIN " + nameof(MAE_Empleados) + " AS AUX_3 ON " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + " = AUX_3." + nameof(MAE_Empleados.id) +
              " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + " IS null AND " +
                          nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@id", _lng_id),
                };

                //Rellenar el Modelo
                mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Obtener_ParaListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_CTG_OrdenComisionServiciosCabecera_Listado_Modelo;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTG_OrdenComisionServiciosCabecera g_mdl_CTG_OrdenComisionServiciosCabecera = null;

        public CTG_OrdenComisionServiciosCabecera Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera) + "." + nameof(CTG_OrdenComisionServiciosCabecera.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTG_OrdenComisionServiciosCabecera;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CTG_OrdenComisionServiciosCabecera = obj_Exferia_Entities.Database.SqlQuery<CTG_OrdenComisionServiciosCabecera>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CTG_OrdenComisionServiciosCabecera.id) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.fecha) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.estado) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "," +
                    nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) +
                " FROM " + nameof(CTG_OrdenComisionServiciosCabecera);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Se utiliza la transaccion por la llamada al procedimiento de almacenado
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                CTG_OrdenComisionServiciosCabecera mdl_CTG_OrdenComisionServiciosCabecera_AGrabar = (CTG_OrdenComisionServiciosCabecera)_mdl_obj;
                CTG_OrdenComisionServiciosCabecera mdl_CTG_OrdenComisionServiciosCabecera_DatosViejos = new CTG_OrdenComisionServiciosCabecera();

                // Ver si existe ######################################################################
                CTG_OrdenComisionServiciosCabecera mdl_CTG_OrdenComisionServiciosCabecera_Final = Obtener_Modelo_Por_Id(mdl_CTG_OrdenComisionServiciosCabecera_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_CTG_OrdenComisionServiciosCabecera_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosCabecera_Final, mdl_CTG_OrdenComisionServiciosCabecera_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosCabecera_AGrabar, mdl_CTG_OrdenComisionServiciosCabecera_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Tesorerias) +
                                           " SET " +
                                               nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "=@idExpediente," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "=@referencia," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "=@descripcion," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.fecha) + "=@fecha," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) + "=@idEmpleado," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "=@idEmpleado_Propuesto," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + "=@idEmpleado_Autorizado," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.estado) + "=@estado," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "=@autorizado," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "=@observaciones," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "=@accionColectiva," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "=@accionIndividual," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "=@accionOtros," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "=@documentacionAdicional," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "=@anticipo," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "=@equiposInformaticos," +
                                               nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(MAE_Tesorerias.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.idExpediente!=null
                            ?   new SqlParameter("@idExpediente", mdl_CTG_OrdenComisionServiciosCabecera_Final.idExpediente.Value)
                            :   new SqlParameter("@idExpediente",  DBNull.Value),
                        new SqlParameter("@referencia",  mdl_CTG_OrdenComisionServiciosCabecera_Final.referencia),
                        new SqlParameter("@descripcion",  mdl_CTG_OrdenComisionServiciosCabecera_Final.descripcion),
                        new SqlParameter("@fecha",  mdl_CTG_OrdenComisionServiciosCabecera_Final.fecha),
                        new SqlParameter("@idEmpleado",  mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Propuesto!=null
                            ?   new SqlParameter("@idEmpleado_Propuesto", mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Propuesto.Value)
                            :   new SqlParameter("@idEmpleado_Propuesto",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Autorizado!=null
                            ?   new SqlParameter("@idEmpleado_Autorizado", mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Autorizado.Value)
                            :   new SqlParameter("@idEmpleado_Autorizado",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.estado!=null
                            ?   new SqlParameter("@estado", mdl_CTG_OrdenComisionServiciosCabecera_Final.estado)
                            :   new SqlParameter("@estado",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.autorizado!=null
                            ?   new SqlParameter("@autorizado", mdl_CTG_OrdenComisionServiciosCabecera_Final.autorizado.Value)
                            :   new SqlParameter("@autorizado",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_CTG_OrdenComisionServiciosCabecera_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.accionColectiva!=null
                            ?   new SqlParameter("@accionColectiva", mdl_CTG_OrdenComisionServiciosCabecera_Final.accionColectiva)
                            :   new SqlParameter("@accionColectiva",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.accionIndividual!=null
                            ?   new SqlParameter("@accionIndividual", mdl_CTG_OrdenComisionServiciosCabecera_Final.accionIndividual)
                            :   new SqlParameter("@accionIndividual",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.accionOtros!=null
                            ?   new SqlParameter("@accionOtros", mdl_CTG_OrdenComisionServiciosCabecera_Final.accionOtros)
                            :   new SqlParameter("@accionOtros",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.documentacionAdicional!=null
                            ?   new SqlParameter("@documentacionAdicional", mdl_CTG_OrdenComisionServiciosCabecera_Final.documentacionAdicional.Value)
                            :   new SqlParameter("@documentacionAdicional",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.anticipo!=null
                            ?   new SqlParameter("@anticipo", mdl_CTG_OrdenComisionServiciosCabecera_Final.anticipo.Value)
                            :   new SqlParameter("@anticipo",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.equiposInformaticos!=null
                            ?   new SqlParameter("@equiposInformaticos", mdl_CTG_OrdenComisionServiciosCabecera_Final.equiposInformaticos.Value)
                            :   new SqlParameter("@equiposInformaticos",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTG_OrdenComisionServiciosCabecera_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         new SqlParameter("@id",  mdl_CTG_OrdenComisionServiciosCabecera_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTG_OrdenComisionServiciosCabecera_Final.id;
                }
                //INSERT
                else
                {
                    mdl_CTG_OrdenComisionServiciosCabecera_Final = new CTG_OrdenComisionServiciosCabecera();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosCabecera_AGrabar, mdl_CTG_OrdenComisionServiciosCabecera_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTG_OrdenComisionServiciosCabecera) +
                                              " (" +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.idExpediente) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.referencia) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.descripcion) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.fecha) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Propuesto) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.idEmpleado_Autorizado) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.estado) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.observaciones) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.accionColectiva) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.accionIndividual) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.accionOtros) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.documentacionAdicional) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.anticipo) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.equiposInformaticos) + "," +
                                                      nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(CTG_OrdenComisionServiciosCabecera.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@idExpediente," +
                                                  "@referencia," +
                                                  "@descripcion," +
                                                  "@fecha," +
                                                  "@idEmpleado," +
                                                  "@idEmpleado_Propuesto," +
                                                  "@idEmpleado_Autorizado," +
                                                  "@estado," +
                                                  "@autorizado," +
                                                  "@observaciones," +
                                                  "@accionColectiva," +
                                                  "@accionIndividual," +
                                                  "@accionOtros," +
                                                  "@documentacionAdicional," +
                                                  "@anticipo," +
                                                  "@equiposInformaticos," +
                                                  "@fechaBorrado" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.idExpediente!=null
                            ?   new SqlParameter("@idExpediente", mdl_CTG_OrdenComisionServiciosCabecera_Final.idExpediente.Value)
                            :   new SqlParameter("@idExpediente",  DBNull.Value),
                        new SqlParameter("@referencia",  mdl_CTG_OrdenComisionServiciosCabecera_Final.referencia),
                        new SqlParameter("@descripcion",  mdl_CTG_OrdenComisionServiciosCabecera_Final.descripcion),
                        new SqlParameter("@fecha",  mdl_CTG_OrdenComisionServiciosCabecera_Final.fecha),
                        new SqlParameter("@idEmpleado",  mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Propuesto!=null
                            ?   new SqlParameter("@idEmpleado_Propuesto", mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Propuesto.Value)
                            :   new SqlParameter("@idEmpleado_Propuesto",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Autorizado!=null
                            ?   new SqlParameter("@idEmpleado_Autorizado", mdl_CTG_OrdenComisionServiciosCabecera_Final.idEmpleado_Autorizado.Value)
                            :   new SqlParameter("@idEmpleado_Autorizado",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.estado!=null
                            ?   new SqlParameter("@estado", mdl_CTG_OrdenComisionServiciosCabecera_Final.estado)
                            :   new SqlParameter("@estado",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.autorizado!=null
                            ?   new SqlParameter("@autorizado", mdl_CTG_OrdenComisionServiciosCabecera_Final.autorizado.Value)
                            :   new SqlParameter("@autorizado",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_CTG_OrdenComisionServiciosCabecera_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.accionColectiva!=null
                            ?   new SqlParameter("@accionColectiva", mdl_CTG_OrdenComisionServiciosCabecera_Final.accionColectiva)
                            :   new SqlParameter("@accionColectiva",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.accionIndividual!=null
                            ?   new SqlParameter("@accionIndividual", mdl_CTG_OrdenComisionServiciosCabecera_Final.accionIndividual)
                            :   new SqlParameter("@accionIndividual",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.accionOtros!=null
                            ?   new SqlParameter("@accionOtros", mdl_CTG_OrdenComisionServiciosCabecera_Final.accionOtros)
                            :   new SqlParameter("@accionOtros",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.documentacionAdicional!=null
                            ?   new SqlParameter("@documentacionAdicional", mdl_CTG_OrdenComisionServiciosCabecera_Final.documentacionAdicional.Value)
                            :   new SqlParameter("@documentacionAdicional",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.anticipo!=null
                            ?   new SqlParameter("@anticipo", mdl_CTG_OrdenComisionServiciosCabecera_Final.anticipo.Value)
                            :   new SqlParameter("@anticipo",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.equiposInformaticos!=null
                            ?   new SqlParameter("@equiposInformaticos", mdl_CTG_OrdenComisionServiciosCabecera_Final.equiposInformaticos.Value)
                            :   new SqlParameter("@equiposInformaticos",  DBNull.Value),
                        mdl_CTG_OrdenComisionServiciosCabecera_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTG_OrdenComisionServiciosCabecera_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTG_OrdenComisionServiciosCabecera), mdl_CTG_OrdenComisionServiciosCabecera_DatosViejos, mdl_CTG_OrdenComisionServiciosCabecera_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar_Estado(long _lng_id, string _str_Estado)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                string str_SQL_Update =
                    " UPDATE " + nameof(CTG_OrdenComisionServiciosCabecera) +
                    "   set " + nameof(CTG_OrdenComisionServiciosCabecera.estado) + "='" + _str_Estado + "' " +
                    " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera.id) + "=" + _lng_id;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Actualizar_Estado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar_Autorizar(long _lng_id, DateTime? _dtt_Autorizar)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                string str_SQL_Update =
                    " UPDATE " + nameof(CTG_OrdenComisionServiciosCabecera) +
                    "   set " + nameof(CTG_OrdenComisionServiciosCabecera.autorizado) + "=" + (_dtt_Autorizar != null ? " '" + _dtt_Autorizar.Value.ToString() + "' " : " null ") +
                    " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera.id) + "=" + _lng_id;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Actualizar_Autorizar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CTG_OrdenComisionServiciosCabecera mdl_CTG_OrdenComisionServiciosCabecera_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_CTG_OrdenComisionServiciosCabecera_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTG_OrdenComisionServiciosCabecera) +
                                                " SET " +
                                                nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(CTG_OrdenComisionServiciosCabecera.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTG_OrdenComisionServiciosCabecera), null, mdl_CTG_OrdenComisionServiciosCabecera_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idOrdenComisionServicioCabecera = (List<long>)_mdl_obj;

                if (lst_idOrdenComisionServicioCabecera != null & lst_idOrdenComisionServicioCabecera.Count > 0)
                {
                    DateTime dtt_FechaActual = DateTime.Now;

                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Fltros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idOrdenComisionServicioCabecera);

                    string str_SQL = " UPDATE " + nameof(CTG_OrdenComisionServiciosCabecera) +
                                        " SET " + nameof(CTG_OrdenComisionServiciosCabecera.fechaBorrado) + "='" + dtt_FechaActual + "' " +
                                     " WHERE " + nameof(CTG_OrdenComisionServiciosCabecera.id) + " in (" + str_Fltros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosCabecera_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
